
set echo on

WITH year_months AS (
       SELECT TO_CHAR(
                 ADD_MONTHS( 
                    DATE '2004-01-01', ROWNUM-1 ), 'YYYYMM' ) AS year_month
       FROM   dual
       CONNECT BY ROWNUM < 12
       )
SELECT co.name
,      ym.year_month
,      NVL(SUM(co.amt),0) AS total_amount 
FROM   year_months ym 
       LEFT OUTER JOIN
       customer_orders co
       ON (TO_CHAR(co.dt,'YYYYMM') = ym.year_month)
GROUP  BY 
       co.name
,      ym.year_month
ORDER  BY
       co.name
,      ym.year_month;

